﻿using Microwave.Classes.Boundary;
using Microwave.Classes.Boundary;
using Microwave.Classes.Boundary.Interfaces;
using NSubstitute;

namespace Microwave.Classes.Test.BoundaryTest;

[TestFixture]
public class BuzzerTest
{
    private ISound _uut;
    private IOutput _output;

    [SetUp]
    public void Setup()
    {
        _output = Substitute.For<IOutput>();

        _uut = new Buzzer(_output);
    }

    [Test]
    public void MakeSound_CalledOnce_BuzzerSound()
    {
        _uut.MakeSound();

        _output.Received(3).OutputLine(Arg.Is<string>(str => str.Contains("BZZZZZZZ")));
    }

    [Test]
    public void MakeSound_CalledMutipleTimes_BuzzerSound()
    {
        _uut.MakeSound();
        _uut.MakeSound();

        _output.Received(6).OutputLine(Arg.Is<string>(str => str.Contains("BZZZZZZZ")));
    }
}
