# Class Diagram

# Sequence Diagram for each new feature 

# State Machine Diagram

# Short description of the new diagrams

# Short Discription of each feature


# Microwave Integration
## Bottom-up test plan 
We chose to use a bottom-up testing strategy because we are working with a microwave system, where the core functionalities are more critical than the user interface. This approach allows us to test the foundational components first those with no dependencies and then progressively move up through the layers, integrating and testing more complex modules only after previous layers are verified.

A visual representation of this structure is shown in the dependency tree below.


## Dependency Tree
![](images/DepedencyTreeSWT.drawio.png)


* Layer 1: The dependency tree above shows four layers, where the first layer consists of components that have no dependencies, like Output, for instance.

* Layer 2: The next layer is mostly hardware components that contain the main functionality of the microwave.

* Layer 3: The third layer consists of components that are mostly UI-based, like Display, for instance.

* Layer 4: The last layer is the controller layer and also the layer with the most dependencies.

The Bottom-up integration test plan can be seen in the table below: 

## Bottum-up Integration Test Plan

| Step | MicrowaveController | CookController | Door | Display | Beeper | Buzzer | Light | StartCancelButton | PowerButton | TimeButton | PowerTube |Timer | MicrowaveControllerState | Output 
|------|--------------|--------|----------|----------|------------|----------|------------|--------------|-------|----|----|----|----|----|
|1 | | | | | | | | | | | | | |T
|2 | | | | | | | | | | | | |T||
|3 | | | | | | | | | | |T|| |X
|4 | | | | | | | | | | | |T| |
|5 | | | T| | | | | | | | | | |
|6 | | | | T | | | | | | | | | |X
|7 | | | | | T | | | | | | | | |X
|8 | | | | | | T | | | | | | | |X
|9 | | | | | | | T |  | |  | | | |X
|10 | X | T |  | X | | | | | | |X|X| |
|11 |T|X|X|X|X|X|X|X|X|X| | |X| 



* T: This module is included, it's the/a top module, and the one driven
* X: This module is included

A small sidenote in the integration plan is that the buttons for the microwave controller are only tested within the MicrowaveController
